package xmlrpcstandaloneserver;

/**
 * Title:        XML-RPC Standalone Server
 * Description:  Einfacher XML-RPC Server
 * Copyright:    Copyright (c) 2001
 * Company:      http://www.joller-voss.ch
 * @author Josef M. Joller
 * @version 1.0
 */

import java.util.Vector; 

import org.apache.xmlrpc.XmlRpc;
import org.apache.xmlrpc.XmlRpcClient;
import org.apache.xmlrpc.XmlRpcException;

public class Client2 {

  // Lokation des Servers (besser als args[...] oder property
  private final static String server_url = "http://localhost:8081/RPC2";

  public static void main (String [] args) {
    try {
      XmlRpc.setDebug(true);
      // Server Objekt
      System.out.println("[Client]lokale Server Instanz bilden" );
      XmlRpcClient server = new XmlRpcClient(server_url);

      // Parameter Liste
      Vector params = new Vector();

      // Erster Teil
      // Server aufrufen und Abfrage starten
      System.out.println("[Client]Server-Methode Test()" );
      // Abfrage
      String result =
               (String) server.execute("beispiel.test", params);
      // Ergebnis
      System.out.println("\n[Client-2]Antwort vom Server-2: "+result);

      // Zweiter Teil
      // Server aufrufen und Abfrage starten
      System.out.println("\n[Client]Server-Methode getName(boolean)" );
      // Abfrage
      boolean flag=true;
      params=new Vector();
      params.addElement(Boolean.TRUE);
      result =
               (String) server.execute("beispiel.getName", params);
      // Ergebnis
      System.out.println("\n[Client-2]Antwort vom Server-2: "+result);


      // Dritter Teil
      // Server aufrufen und Abfrage starten
      params=new Vector();
      params.addElement("Das");
      params.addElement(" ist nett!");
      System.out.println("\n[Client]Server-Methode Concatenate()" );

      // Abfrage
      result =
               (String) server.execute("beispiel.concatinate", params);
      // Ergebnis
      System.out.println("\n[Client-2]Antwort vom Server-2: "+result);


    } catch (XmlRpcException exception) {
      System.err.println("Client: XML-RPC Fehler #" +
                          Integer.toString(exception.code) + ": " +
                         exception.toString());
      exception.printStackTrace();
    } catch (Exception exception) {
      System.err.println("Client: " + exception.toString());
      exception.printStackTrace();
    }
  }
}
