package xmlrpcstandaloneserver;

/**
 * Title:        XML-RPC Standalone Server
 * Description:  Einfacher XML-RPC Server
 * Copyright:    Copyright (c) 2001
 * Company:      http://www.joller-voss.ch
 * @author Josef M. Joller
 * @version 1.0
 */
import java.util.*;

public class Flaeche {

  // Double Wrapper Klasse, wegen XML-RPC
  public Double rechteckFlaeche(double laenge, double breite) {
    System.out.println("[Flaeche]Berechnung der Rechteck-Flaeche");
    return new Double(laenge*breite);
  }

  public Double kreisFlaeche(double radius) {
    System.out.println("[Flaeche]Berechnung der Kreis-Flaeche");
    return new Double(radius*radius*Math.PI);
  }

  // Erweiterung: beliebige Auswahl der geom. Figur
  public Double anyFlaeche(Hashtable argumente){
    Double wert;
    wert = new Double(0);

    String procedureTypus = (String)argumente.get("typus");

    if (procedureTypus.equals("kreis")) {
      Double radius = (Double)(argumente.get("radius"));
      wert = kreisFlaeche(radius.doubleValue());
    }
    if (procedureTypus.equals("rechteck")) {
      Double laenge = (Double)(argumente.get("laenge"));
      Double breite = (Double)(argumente.get("breite"));
      wert = rechteckFlaeche(laenge.doubleValue(),breite.doubleValue());
    }
    return wert;
  }
}