package xmlrpcstandaloneserver;

/**
 * Title:        XML-RPC Standalone Server
 * Description:  Einfacher XML-RPC Server
 * Copyright:    Copyright (c) 2001
 * Company:      http://www.joller-voss.ch
 * @author Josef M. Joller
 * @version 1.0
 */

import java.io.IOException;
import java.util.Hashtable;
import java.util.Vector;

import org.apache.xmlrpc.XmlRpcClient;
import org.apache.xmlrpc.XmlRpcException;

public class FlaechenClient {

  public static void main(String[] args) {
    if (args.length <1 ) {
      System.out.println("Usage: java FlaechenClient ([radius] | [laenge] [breite]) ");
      // System.exit(-1);
      args = new String[2];
      args[0] = "2.14";
    }
    try {
      // kreieren des Clients
      XmlRpcClient client = new XmlRpcClient("http://localhost:8099");
      System.out.println("[FlaechenClient]Der Client wurde gestartet");

      // Parameter in den Vector stecken
      Vector param = new Vector();
      param.addElement(new Double(args[0]));

      // Methodenaufruf (Prozeduraufruf)
      Object result = client.execute("flaeche.kreisFlaeche",param);
      System.out.println("[FlaechenClient]Methodenaufruf war erfolgreich");

      // Ausgabe der Flche
      System.out.println("[FlaechenClient]\n\tFlaeche: "+result);

      //
      // Erweiterung
      //
      Double radius = new Double(args[0]);

      Hashtable procedureHash = new Hashtable();
      procedureHash.put("typus", "kreis");
      procedureHash.put("radius", radius);

      Vector params = new Vector();
      params.addElement(procedureHash);

      // Methodenaufruf (Prozeduraufruf)
      result = client.execute("flaeche.anyFlaeche",params);
      System.out.println("[FlaechenClient]Methodenaufruf war erfolgreich");

      // Ausgabe der Flche
      System.out.println("[FlaechenClient]\n\tFlaeche: "+result);

    } catch(IOException ioe) {
      System.out.println("IO Exception: "+ioe.getMessage());
      ioe.printStackTrace();
    } catch(XmlRpcException xe) {
      System.out.println("XmlRpc Exception: "+xe.getMessage());
      xe.printStackTrace();
    }
  }
}