package xmlrpcstandaloneserver;

/**
 * Title:        XML-RPC Standalone Server
 * Description:  Einfacher XML-RPC Server
 * Copyright:    Copyright (c) 2001
 * Company:      http://www.joller-voss.ch
 * @author Josef M. Joller
 * @version 1.0
 */
import java.io.IOException;

import org.apache.xmlrpc.WebServer;

public class FlaechenServer {
  public static void main(String[] args) {
    if (args.length < 1) {
      System.out.println("Usage : java FlaechenServer [port]");
      //System.exit(-1);
      args = new String[2];
      args[0] = "8099";
    }

    try {
      // Server starten
      System.out.println("[FlaechenServer]XML-RPC Server wird gestartet");
      WebServer server = new WebServer(Integer.parseInt(args[0]));
      System.out.println("[FlaechenServer]XML-RPC Server gestartet");

      // Flchenberechnung registrieren
      System.out.println("[FlaechenServer]XML-RPC Flaechen Handler registrieren");
      server.addHandler("flaeche",new Flaeche());
      System.out.println("[FlaechenServer]XML-RPC Flaechen Handler registriert");

      // warten auf Anfragen
      System.out.println("[FlaechenServer]warten auf Anfragen");
    } catch(IOException ioe) {
      System.out.println("[FlaechenServer]Der XML-RPC Server konnte nicht gestartet werden");
      ioe.printStackTrace();
    }
  }
}