package xmlrpcstandaloneserver;

/**
 * Title:        XML-RPC Standalone Server
 * Description:  Einfacher XML-RPC Server
 * Copyright:    Copyright (c) 2001
 * Company:      http://www.joller-voss.ch
 * @author Josef M. Joller
 * @version 1.0
 */
import java.io.IOException;
import java.net.InetAddress;
import java.util.Random;
import java.util.Vector;

import org.apache.xmlrpc.XmlRpcClient;
import org.apache.xmlrpc.XmlRpcException;

public class GetSetClient {

  public GetSetClient() {
    System.out.println("[GetSetClient]Konstruktor");
  }
  public static void main(String[] args) {
    GetSetClient getSetClient1 = new GetSetClient();
    args = new String[5];
    args[0] = "9898";

    args[1] = "get";
    args[2] = "set";

    args[3] = "300";
    args[4] = "550";

    String getODERset = new String(args[2]); // zuerst setzen
    if (!( (getODERset.equals("get")) || (getODERset.equals("set") ) )) {
      System.out.println("usage: java GetSetClient [port] [get|set] [value]");
      System.exit(-1);
    }

    try {
      //XmlRpc.setDebug(true);
      // Client Konstruktion
      XmlRpcClient client = new XmlRpcClient("http://localhost:"+args[0]);
      // lokale Identitt
      InetAddress address = InetAddress.getLocalHost();
      String ipAddress = address.toString();

      // Request aufbauen
      Vector param = new Vector();
      param.addElement(ipAddress);

      Random r = new Random();
      int j=0, k=0;
      for (int i=0; i<10; i++) {
        j=r.nextInt(2);// 0 oder 1 : get oder set
        k=r.nextInt(2);// 0 oder 1 : 200 oder 150
        getODERset = args[1+j];
        System.out.println("[GetSetClient.Debug]getODERset="+getODERset);
        if (getODERset.equals("set")) {
          Integer newValue = new Integer(args[3+k]);
          System.out.println("[GetSetClient.Debug]newValue="+newValue);
          param.addElement(newValue);
        }

        // Request absetzen
        Object result = null;
        if (getODERset.equals("set")) {
          result = client.execute("GetSet.setValue", param);
        } else {
          result = client.execute("GetSet.getValue", param);
        }

        // Ergebnis anzeigen
        System.out.println("\n[GetSetClient]Antwort von Server");
        System.out.println("\t"+result);

        // Parameter lschen
        if (getODERset.equals("set")) {
          param.remove(1);
        }
      }

    } catch(IOException ioe) {
      ioe.printStackTrace();
    } catch(XmlRpcException xe) {
      xe.printStackTrace();
    }

  }
}