package xmlrpcstandaloneserver;

import org.apache.xmlrpc.*;
import java.util.*;

/**
 * Title:        XML-RPC Standalone Server
 * Description:  Einfacher XML-RPC Server
 * Copyright:    Copyright (c) 2001
 * Company:      http://www.joller-voss.ch
 * @author Josef M. Joller
 * @version 1.0
 */

public class HandlerClient {

  // Lokation des Servers (besser als args[...] oder property
  private final static String server_url = "http://localhost:8099/RPC2";

  public HandlerClient() {
    System.out.println("[HandlerClient]Konstruktor");
  }
  public static void main(String[] args) {
    HandlerClient handlerClient1 = new HandlerClient();
    try {
      XmlRpc.setDebug(true);
      // Server Objekt
      XmlRpcClient server = new XmlRpcClient(server_url);

      // Parameter Liste
      Vector params = new Vector();
      params.addElement(new Integer(5));
      params.addElement(new Integer(3));

      // Server aufrufen und Abfrage starten
      System.out.println("[HandlerClient]lokale Server Instanz bilden" );
      System.out.println("[HandlerClient]Server-Methode XMLRPCHandler" );
      // Abfrage
      Object result =
               server.execute("HandlerTest.XMLRPCHandler", params);
      //Ausgabe der Antwort
      System.out.println("\n[HandlerClient]Antwort:"+result );
    } catch (XmlRpcException exception) {
      System.err.println("[HandlerClient]XML-RPC Fehler #" +
                          Integer.toString(exception.code) + ": " +
                         exception.toString());
    } catch (Exception exception) {
      System.err.println("[HandlerClient]" + exception.toString());
    }

  }
}