package xmlrpcstandaloneserver;

/**
 * Title:        XML-RPC Standalone Server
 * Description:  Einfacher XML-RPC Server
 * Copyright:    Copyright (c) 2001
 * Company:      http://www.joller-voss.ch
 * @author Josef M. Joller
 * @version 1.0
 */
import javax.swing.UIManager;

import org.apache.xmlrpc.WebServer;
import org.apache.xmlrpc.XmlRpc;

public class Server2 {

	static String mVersion = "1.0";
	static Status mStatus;

	public Server2() {
		try {

			try {
				UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			}
			catch (Exception e) {
			}

			mStatus = new Status();
			mStatus.initComponents();
			mStatus.setVisible(true);

			StartXMLRPCServer(8081, "beispiel", new Exposed());

			Log("XML-RPC Server 2 Version " + mVersion + " gestartet...\n");
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void StartXMLRPCServer(int port, String serviceName, Object serviceHandler) throws Exception {
		WebServer webserver = new WebServer (port);
		webserver.addHandler(serviceName, serviceHandler);
	}

	public static void Log(String message) {
		mStatus.mText.append(message);
	}

	//
	static public void main(String[] args) {
                XmlRpc.setDebug(true);
		new Server2();
	}
}
