package xmlrpcstandaloneserver;

/**
 * Title:        XML-RPC Standalone Server
 * Description:  Einfacher XML-RPC Server
 * Copyright:    Copyright (c) 2001
 * Company:      http://www.joller-voss.ch
 * @author Josef M. Joller
 * @version 1.0
 */

import java.awt.Dimension;

import javax.swing.JMenuBar;

public class Status extends javax.swing.JFrame {

	javax.swing.JScrollPane mScroller = new javax.swing.JScrollPane();
	javax.swing.JTextArea mText = new javax.swing.JTextArea();

	public Status() {
	}

	public void initComponents() throws Exception {
		mScroller.setVisible(true);
		mText.setVisible(true);
		mText.setFont(new java.awt.Font("Verdana", 0, 10));
		setLocation(new java.awt.Point(0, 0));
		getContentPane().setLayout(new java.awt.BorderLayout(0, 0));
		setTitle("XML-RPC Server");

		mScroller.getViewport().add(mText);
		getContentPane().add(mScroller, "Center");

		setSize(new java.awt.Dimension(300, 200));

		// event handling
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});
	}

  	private boolean mShown = false;

	public void addNotify() {
		super.addNotify();

		if (mShown)
			return;

		// resize frame
		JMenuBar jMenuBar = getJMenuBar();
		if (jMenuBar != null) {
			int jMenuBarHeight = jMenuBar.getPreferredSize().height;
			Dimension dimension = getSize();
			dimension.height += jMenuBarHeight;
			setSize(dimension);
		}

		mShown = true;
	}

	// Close
	void thisWindowClosing(java.awt.event.WindowEvent e) {
		setVisible(false);
		dispose();
		System.exit(0);
	}

}
