package xmlrpcstandaloneserver;

/**
 * Title:        XML-RPC Standalone Server
 * Description:  Einfacher XML-RPC Server
 * Copyright:    Copyright (c) 2001
 * Company:      http://www.joller-voss.ch
 * @author Josef M. Joller
 * @version 1.0
 */

import java.util.Vector;
import java.util.Hashtable;
import org.apache.xmlrpc.*;

public class XMLRPCClient {

  // Lokation des Servers (besser als args[...] oder property
  private final static String server_url = "http://localhost:8080/RPC2";

  public static void main (String [] args) {
    try {
      XmlRpc.setDebug(true);
      // Server Objekt
      XmlRpcClient server = new XmlRpcClient(server_url);

      // Parameter Liste
      Vector params = new Vector();
      params.addElement(new Integer(5));
      params.addElement(new Integer(3));

      // Server aufrufen und Abfrage starten
      System.out.println("[Client]lokale Server Instanz bilden" );
      System.out.println("[Client]Server-Methode summeUndDifferenz" );
      // Abfrage
      Hashtable result =
               (Hashtable) server.execute("beispiel.summeUndDifferenz", params);
      // Ergebnis
      int sum = ((Integer) result.get("summe")).intValue();
      int difference = ((Integer) result.get("differenz")).intValue();

      // Ausgabe
      System.out.println("\n[Client]Eingabe: \n\tParameter 1 = 5; \n\tParameter 2 = 3;");
      System.out.println("[Client]Ergebnisse: \n\tSumme: " + Integer.toString(sum) +
                                   ";\n\tDifferenz: " +
                                   Integer.toString(difference)+";");

    } catch (XmlRpcException exception) {
      System.err.println("XMLRPCClient: XML-RPC Fehler #" +
                          Integer.toString(exception.code) + ": " +
                         exception.toString());
    } catch (Exception exception) {
      System.err.println("XMLRPCClient: " + exception.toString());
    }
  }
}
