package xmlrpcstandaloneserver;

/**
 * Title:        XML-RPC Standalone Server
 * Description:  Einfacher XML-RPC Server
 * Copyright:    Copyright (c) 2001
 * Company:      http://www.joller-voss.ch
 * @author Josef M. Joller
 * @version 1.0
 */

import java.util.Hashtable;
import org.apache.xmlrpc.*;

public class XMLRPCServer {
	public XMLRPCServer() {
		// regulaeres Java Objekt
		// Public Methoden sind dem XML-RPC Client bekannt
		System.out.println("[Server]Konstruktor");
	}

	public Hashtable summeUndDifferenz(int x, int y) {
		Hashtable result = new Hashtable();
		System.out.println(
			"[Server]summeUndDifferenz: Parameter: " + x + "; " + y + ";");
		System.out.println("\tSumme: " + (x + y) + ";");
		result.put("summe", new Integer(x + y));
		System.out.println("\tDifferenz: " + (x - y) + ";");
		result.put("differenz", new Integer(x - y));
		return result;
	}

	public static void main(String[] args) {
		try {
			XmlRpc.setDebug(true);
			// Aufruf <http://localhost:8080/RPC2>.
			System.out.println(
				"[Server]Instanziern des Web Servers: localhost:8080");
			WebServer server = new WebServer(8080);
			// Instanz dieses Servers bilden und auf Anfragen warten
			System.out.println("[Server]Instanziern des XML-RPC Servers");
			server.addHandler("beispiel", new XMLRPCServer());

		} catch (Exception exception) {
			System.err.println("[Server]Fehler " + exception.toString());
		}
	}
}
