/*
 * Created on 03.10.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package xmlrpcstandaloneserver;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Date;
import java.util.Vector;

import org.apache.xmlrpc.XmlRpcClient;
import org.apache.xmlrpc.XmlRpcException;

/**
 * @author jjoller
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ZeitObjektClient {
	// man knnte auch einfach ein Date Objekt bermitteln:
	// Date ist ein untersttzter Datentyp

	// Die Server URL / der Server Port.
	private final static String server_url =
		"http://localhost:9090/";

	public static void main (String [] args) {
		long lClient=0, lServer=0;
		try {

			// Severobjekt.
			XmlRpcClient serverAnbindung = new XmlRpcClient(server_url);

			// Parameterliste.
			Vector params = new Vector();
			System.out.println("[ZeitObjektClient]Parameter");

			Date clientZeit = new java.util.Date();
			System.out.println("[ZeitObjektClient]clientZeit: " + clientZeit);
			lClient = clientZeit.getTime();
			byte[] clientDate = null;

			try {
				// Serialisiere in ein Byte Array
				ByteArrayOutputStream bos = new ByteArrayOutputStream();
				ObjectOutputStream out = new ObjectOutputStream(bos);
				out.writeObject(clientZeit);
				out.close();

				// Bytes des Objekts
				clientDate = bos.toByteArray();
			} catch (IOException e) {
			}
			params.addElement(clientDate);

			// Remote procedure Call
			System.out.println("[ZeitObjektClient]serverZeit(clientZeit)");
			byte[] baServerZeit =
				(byte[])serverAnbindung.execute("ZeitObjektServer.serverZeit", params);
			
			// Ausgabe des Server Objekts
			try {
				// Deserialisieren des Byte Arrays
				ObjectInputStream in =
					new ObjectInputStream(new ByteArrayInputStream(baServerZeit));
				Date serverDatum = (java.util.Date) in.readObject();
				in.close();
				System.out.println("[ZeitObjektClient]serverZeit: " + serverDatum);
				lServer = serverDatum.getTime();
				System.out.println("[ZeitObjektClient]serverZeit (Millisekunden): " + lServer);
				System.out.println("[ZeitObjektClient]Zeitdifferenz (Millisekunden): " + (lServer-lClient));
			} catch (ClassNotFoundException e) {
				e.printStackTrace(System.err);
			} catch (IOException e) {
				e.printStackTrace(System.err);
			}

		} catch (XmlRpcException exception) {
			System.err.println("[HelloWorldClient]XML-RPC Fault #" +
							   Integer.toString(exception.code) + ": " +
							   exception.toString());
			exception.printStackTrace();
		} catch (Exception exception) {
			System.err.println("[HelloWorldClient]Fehler: " + exception.toString());
			exception.printStackTrace();
		}
	}
}
